/*

SELECT  TITEM.ITEMID ,TITEM.ITEMADI ,HDOSYA.HDOSYAID,HESAPISL.HESAPISLID,TITEM.BARKOD,NULL SN, NULL GTIN ,NULL XD, NULL BN,DBO.TARIHAL(ITARIH) ITARIH  INTO TEMP_HESAPISL_GTIN FROM HESAPISL  
INNER JOIN TITEM ON TITEM .ITEMID=HESAPISL.ITEMID
INNER JOIN HDOSYA ON HDOSYA.HDOSYAID=HESAPISL.HDOSYAID
INNER JOIN HMALZILAC ON HMALZILAC.HESAPISLID=HESAPISL.HESAPISLID

WHERE ITEMTURUID=3 AND ITARIH>'2021-10-01' AND IPTAL=0 AND HDIPTAL=0 AND MDLTAKIPVAR=1 AND MDLISLEMSIRANO IS  NULL AND HESAPISL.MDLKAYDET=1  AND ISNULL(HMALZILAC.GTIN,'')=''
AND TITEM.BARKOD IN (
  SELECT BARKOD FROM TKAREKODZORUNLUSTOK) --AND HDOSYA.HDOSYAID=383328 AND BARKOD='8699786751408'
  ORDER BY HESAPISLID



 SELECT   * INTO TEMP_ITS FROM ITS WHERE   ISNULL(KULLANILDI,0)=0 ORDER BY XD
 */


DECLARE @HDOSYAID AS INT
DECLARE @BARKOD AS NVARCHAR(50)
DECLARE @HESAPISLID AS INT
DECLARE @DEGER AS NVARCHAR(50)

DECLARE @SN AS NVARCHAR(50) 
DECLARE @GTIN AS NVARCHAR(50)  
DECLARE @XD AS DATETIME 
DECLARE @BN AS NVARCHAR(50)   
DECLARE @ITARIH AS DATETIME 
DECLARE @SATIR AS INT

--SET @HDOSYAID=383328
SET @SATIR=0
DECLARE HDOSYA_ICD_CURSOR CURSOR
   FOR  SELECT HDOSYAID,HESAPISLID,BARKOD,ITARIH FROM TEMP_HESAPISL_GTIN  

OPEN HDOSYA_ICD_CURSOR
FETCH NEXT FROM HDOSYA_ICD_CURSOR INTO @HDOSYAID,@HESAPISLID,@BARKOD,@ITARIH
WHILE @@FETCH_STATUS = 0
BEGIN
    SET @SATIR=@SATIR+1
	PRINT CAST(@SATIR AS NVARCHAR(10))+'.Kayıt'
	SELECT TOP 1  @DEGER=ITSID,@SN=SN   ,@GTIN=GTIN  ,@XD=XD   ,@BN=BN   FROM TEMP_ITS WHERE  GTIN=@BARKOD AND ISNULL(KULLANILDI,0)=0  AND XD>@ITARIH  ORDER BY XD
    IF @@rowcount>0
	BEGIN
      PRINT 'hdosyaıd:'+CAST(@HESAPISLID AS NVARCHAR(50))+' hesapıslıd:'+CAST(@HESAPISLID AS NVARCHAR(50))+' BARKOD='+@BARKOD+'  ok!!'
      UPDATE TEMP_HESAPISL_GTIN SET SN=@SN   ,GTIN=@GTIN  ,XD=@XD   ,BN=@BN    WHERE HDOSYAID=@HDOSYAID AND HESAPISLID=@HESAPISLID AND BARKOD=@BARKOD
	  UPDATE TEMP_ITS SET KULLANILDI=1 WHERE ITSID=@DEGER
	END
	ELSE
	BEGIN
		PRINT'hdosyaıd:'+CAST(@HESAPISLID AS NVARCHAR(50))+' hesapıslıd:'+CAST(@HESAPISLID AS NVARCHAR(50))+ ' BARKOD='+@BARKOD+'  ITS EŞLEŞMEDİ'
	END

	FETCH NEXT FROM HDOSYA_ICD_CURSOR INTO  @HDOSYAID,@HESAPISLID,@BARKOD,@ITARIH
END

CLOSE HDOSYA_ICD_CURSOR
DEALLOCATE HDOSYA_ICD_CURSOR
